/**
 * Contract between the Store and Soya. This interface is needed to distinguish
 * framework concern for rendering and application concern for data fetching.
 *
 * Soya has a default implementation to use with Redux. Other implementations
 * may be created for other client-side architecture or data fetching library.
 *
 * @CLIENT_SERVER
 */'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}var 
Store = (function () {function Store() {_classCallCheck(this, Store);}_createClass(Store, [{ key: '_getState', 
    /**
     * @return {any}
     */value: 
    function _getState() {
      throw new Error('Abstract method not implemented.');}


    /**
     * Tells this Store that upon first Segment conflict, it has to nullify the
     * Segment's state, second conflict throws error as usual.
     *
     * IMPORTANT NOTE: This only happens on first Segment conflict - second
     * conflict means there are indeed Segment name clash, and Store should
     * rightfully throw an Error.
     */ }, { key: '_mayHotReloadSegments', value: 
    function _mayHotReloadSegments() {
      throw new Error('Abstract method not implemented.');}


    /**
     * @return {boolean}
     */ }, { key: 'shouldRenderBeforeServerHydration', value: 
    function shouldRenderBeforeServerHydration() {
      return false;}


    /**
     * Called by Soya server and client runtime when rendering pages. Calls the
     * given callback when all blocking render is complete.
     *
     * @param {RenderType} renderType
     * @return {Promise}
     */ }, { key: 'hydrate', value: 
    function hydrate(renderType) {
      throw new Error('Abstract method not implemented.');} }]);return Store;})();exports['default'] = Store;module.exports = exports['default'];
//# sourceMappingURL=Store.js.map