'use strict';Object.defineProperty(exports, '__esModule', { value: true });var _createClass = (function () {function defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ('value' in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}return function (Constructor, protoProps, staticProps) {if (protoProps) defineProperties(Constructor.prototype, protoProps);if (staticProps) defineProperties(Constructor, staticProps);return Constructor;};})();var _get = function get(_x, _x2, _x3) {var _again = true;_function: while (_again) {var object = _x, property = _x2, receiver = _x3;desc = parent = getter = undefined;_again = false;if (object === null) object = Function.prototype;var desc = Object.getOwnPropertyDescriptor(object, property);if (desc === undefined) {var parent = Object.getPrototypeOf(object);if (parent === null) {return undefined;} else {_x = parent;_x2 = property;_x3 = receiver;_again = true;continue _function;}} else if ('value' in desc) {return desc.value;} else {var getter = desc.get;if (getter === undefined) {return undefined;}return getter.call(receiver);}}};function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { 'default': obj };}function _defineProperty(obj, key, value) {if (key in obj) {Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });} else {obj[key] = value;}return obj;}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError('Cannot call a class as a function');}}function _inherits(subClass, superClass) {if (typeof superClass !== 'function' && superClass !== null) {throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;}var _react = require('react');var _react2 = _interopRequireDefault(_react);var _ReduxStoreJs = require(

'./ReduxStore.js');var _ReduxStoreJs2 = _interopRequireDefault(_ReduxStoreJs);

/**
 * Components that wanted to use Soya's redux container may use this.
 *
 * @CLIENT_SERVER
 */var 
DataComponent = (function (_React$Component) {_inherits(DataComponent, _React$Component);
  function DataComponent(props, context) {_classCallCheck(this, DataComponent);
    _get(Object.getPrototypeOf(DataComponent.prototype), 'constructor', this).call(this, props, context);
    this.state = { 
      action: {}, 
      unsubscribe: {} };


    if (!(this.getReduxStore() instanceof _ReduxStoreJs2['default'])) {
      throw new Error('ReduxStore is not properly wired to this component: ' + this.constructor.name + '.');}}



  /**
   * Defaults to getting ReduxStore instance from props.store. If you want to
   * use context you can override this method.
   *
   * @returns {ReduxStore}
   */_createClass(DataComponent, [{ key: 'getReduxStore', value: 
    function getReduxStore() {
      return this.props.reduxStore;}


    /**
     * Registers Segment and queries required by this component to ReduxStore
     * instance. Child components should override this to specify their data
     * requirements.
     *
     * NOTE: Registration should be done with register() method.
     */ }, { key: 'registerSegments', value: 
    function registerSegments() {}



    /**
     * @param {Segment} segment
     * @param {any} query
     * @param {string} stateName
     * @param {?Object} queryOptions
     * @param {?Object} hydrationOption
     */ }, { key: 'register', value: 
    function register(segment, query, stateName, queryOptions, hydrationOption) {var _setState2, _this = this;
      // Unregister if already registered.
      this.unregister(stateName);
      console.log('register', segment, this.state);
      var callback = function callback(newState) {
        _this.setState(_defineProperty({}, stateName, newState));};


      var storeRef = this.getReduxStore().register(segment, query, callback, 
      this, queryOptions, hydrationOption);
      var action = this.state.action;
      var unsubscribe = this.state.unsubscribe;
      action[segment._getName()] = storeRef.actionCreator;
      unsubscribe[stateName] = storeRef.unsubscribe;
      this.setState((_setState2 = {}, _defineProperty(_setState2, 
      stateName, storeRef.getState()), _defineProperty(_setState2, 'action', 
      action), _defineProperty(_setState2, 'unsubscribe', 
      unsubscribe), _setState2));}



    /**
     * @param {string} stateName
     */ }, { key: 'unregister', value: 
    function unregister(stateName) {
      console.log('unregister', stateName);
      delete this.state[stateName];
      if (this.state.unsubscribe[stateName]) {
        this.state.unsubscribe[stateName]();
        delete this.state.unsubscribe[stateName];}}



    /**
     * Registers the store. Run at both client and server side when rendering.
     */ }, { key: 'componentWillMount', value: 
    function componentWillMount() {
      this.registerSegments();
      console.log('COMPONENT WILL MOUNT');}


    /**
     * Unregister all segments.
     */ }, { key: 'componentWillUnmount', value: 
    function componentWillUnmount() {
      console.log('COMPONENT WILL UNMOUNT');
      this.getReduxStore().unsubscribe(this);} }]);return DataComponent;})(_react2['default'].Component);exports['default'] = DataComponent;module.exports = exports['default'];
//# sourceMappingURL=DataComponent.js.map